       IDENTIFICATION DIVISION.
       PROGRAM-ID. "UPDOGERR".
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
           EXEC SQL BEGIN DECLARE SECTION END-EXEC.
       01  EMP-REC-VARS.
           05  EMP-NAME      PIC X(10) VARYING.
           05  EMP-NUMBER    PIC S9(4) COMP VALUE ZERO.
           05  SALARY        PIC S9(5)V99 COMP-3 VALUE ZERO.
           05  COMMISSION    PIC S9(5)V99 COMP-3 VALUE ZERO.
           05  COMM-IND      PIC S9(4) COMP VALUE ZERO.
           EXEC SQL END DECLARE SECTION END-EXEC.
           EXEC SQL INCLUDE SQLCA END-EXEC.
       01 TABLE-ITEM PIC X OCCURS 10 TIMES INDEXED BY IDX.
       LINKAGE SECTION.
       01 LNK-EMP-NUMBER     PIC S9(4) COMP.
       01 LNK-EMP-NAME       PIC X(10).
       01 LNK-ERR-FLG        PIC X(1).
       PROCEDURE DIVISION
                 USING LNK-EMP-NUMBER LNK-EMP-NAME LNK-ERR-FLG.
       MAIN-PARA.
           MOVE LNK-EMP-NUMBER TO EMP-NUMBER.
           PERFORM GET-EMPNAME.
           DISPLAY "EMPNAME BEFORE UPDATE: " EMP-NAME-ARR
               UPON CONSOLE.
           PERFORM UPD-EMPNAME.
           PERFORM GET-EMPNAME.
           DISPLAY "EMPNAME AFTER UPDATE: " EMP-NAME-ARR
               UPON CONSOLE.
           PERFORM ERR-HANDLING.
           MOVE EMP-NAME-ARR TO LNK-EMP-NAME.
           GOBACK.

       GET-EMPNAME.
           MOVE SPACES TO EMP-NAME-ARR.
           EXEC SQL
               SELECT ENAME INTO :EMP-NAME
               FROM EMP_WK
               WHERE EMPNO = :EMP-NUMBER
           END-EXEC.
           EXIT.

       UPD-EMPNAME.
           MOVE 10 TO EMP-NAME-LEN.
           MOVE LNK-EMP-NAME TO EMP-NAME-ARR.
           EXEC SQL
               UPDATE EMP_WK
               SET ENAME = :EMP-NAME
               WHERE EMPNO = :EMP-NUMBER
           END-EXEC.
           EXIT.

       ERR-HANDLING.
           IF LNK-ERR-FLG = 'Y' THEN
             SET IDX TO 11
             MOVE SPACE TO TABLE-ITEM(IDX)
           END-IF.
           EXIT.
